<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: siggen::ThreadManagerPowerSaver Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classsiggen_1_1_thread_manager_power_saver.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="classsiggen_1_1_thread_manager_power_saver-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">siggen::ThreadManagerPowerSaver Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>default thread manager using mutexes and condition variables  
 <a href="classsiggen_1_1_thread_manager_power_saver.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_thread_manager_power_saver_8h_source.html">ThreadManagerPowerSaver.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for siggen::ThreadManagerPowerSaver:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classsiggen_1_1_thread_manager_power_saver.png" usemap="#siggen::ThreadManagerPowerSaver_map" alt=""/>
  <map id="siggen::ThreadManagerPowerSaver_map" name="siggen::ThreadManagerPowerSaver_map">
<area href="classsiggen_1_1_thread_manager.html" title="common implementation of a ThreadManager base" alt="siggen::ThreadManager" shape="rect" coords="0,56,216,80"/>
<area href="classsiggen_1_1_thread_manager_base.html" title="base for threading manager" alt="siggen::ThreadManagerBase" shape="rect" coords="0,0,216,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a2434e6d1fc566048154d81380065df1e"><td class="memItemLeft" align="right" valign="top"><a id="a2434e6d1fc566048154d81380065df1e"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_thread_manager_power_saver.html#a2434e6d1fc566048154d81380065df1e">ThreadManagerPowerSaver</a> (<a class="el" href="structsiggen_1_1_data.html">Data</a> &amp;&amp;data)</td></tr>
<tr class="memdesc:a2434e6d1fc566048154d81380065df1e"><td class="mdescLeft">&#160;</td><td class="mdescRight">spawns data.m_ThreadCount threads to do the work <br /></td></tr>
<tr class="separator:a2434e6d1fc566048154d81380065df1e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac96e31c7a171d9309dcb04b4232cec58"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_thread_manager_power_saver.html#ac96e31c7a171d9309dcb04b4232cec58">ProcessToBuffer</a> (std::vector&lt; char &gt; &amp;result) override</td></tr>
<tr class="memdesc:ac96e31c7a171d9309dcb04b4232cec58"><td class="mdescLeft">&#160;</td><td class="mdescRight">reads a block of data from input file, and enqueues the data for further processing by threads  <a href="classsiggen_1_1_thread_manager_power_saver.html#ac96e31c7a171d9309dcb04b4232cec58">More...</a><br /></td></tr>
<tr class="separator:ac96e31c7a171d9309dcb04b4232cec58"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classsiggen_1_1_thread_manager"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classsiggen_1_1_thread_manager')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classsiggen_1_1_thread_manager.html">siggen::ThreadManager</a></td></tr>
<tr class="memitem:af6aa77ae67c245f4abaaf6176f5eb265 inherit pub_methods_classsiggen_1_1_thread_manager"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_thread_manager.html#af6aa77ae67c245f4abaaf6176f5eb265">ThreadManager</a> (<a class="el" href="structsiggen_1_1_data.html">Data</a> &amp;&amp;data)</td></tr>
<tr class="memdesc:af6aa77ae67c245f4abaaf6176f5eb265 inherit pub_methods_classsiggen_1_1_thread_manager"><td class="mdescLeft">&#160;</td><td class="mdescRight">construct thread manager with data to work on  <a href="classsiggen_1_1_thread_manager.html#af6aa77ae67c245f4abaaf6176f5eb265">More...</a><br /></td></tr>
<tr class="separator:af6aa77ae67c245f4abaaf6176f5eb265 inherit pub_methods_classsiggen_1_1_thread_manager"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a26a2a10c5fa543ea86c5058d69e0ee87"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_thread_manager_power_saver.html#a26a2a10c5fa543ea86c5058d69e0ee87">ConsumerThread</a> (size_t threadIndex)</td></tr>
<tr class="memdesc:a26a2a10c5fa543ea86c5058d69e0ee87"><td class="mdescLeft">&#160;</td><td class="mdescRight">basic loop for spawned consumer threads  <a href="classsiggen_1_1_thread_manager_power_saver.html#a26a2a10c5fa543ea86c5058d69e0ee87">More...</a><br /></td></tr>
<tr class="separator:a26a2a10c5fa543ea86c5058d69e0ee87"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_static_methods_classsiggen_1_1_thread_manager_base"><td colspan="2" onclick="javascript:toggleInherit('pub_static_methods_classsiggen_1_1_thread_manager_base')"><img src="closed.png" alt="-"/>&#160;Static Public Member Functions inherited from <a class="el" href="classsiggen_1_1_thread_manager_base.html">siggen::ThreadManagerBase</a></td></tr>
<tr class="memitem:acb6c87062d2f75f4ad9d21801950e61e inherit pub_static_methods_classsiggen_1_1_thread_manager_base"><td class="memItemLeft" align="right" valign="top">static std::unique_ptr&lt; <a class="el" href="classsiggen_1_1_thread_manager_base.html">ThreadManagerBase</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_thread_manager_base.html#acb6c87062d2f75f4ad9d21801950e61e">Factory</a> (ThreadingPolicy policy, <a class="el" href="structsiggen_1_1_data.html">Data</a> &amp;&amp;data)</td></tr>
<tr class="memdesc:acb6c87062d2f75f4ad9d21801950e61e inherit pub_static_methods_classsiggen_1_1_thread_manager_base"><td class="mdescLeft">&#160;</td><td class="mdescRight">creates threading manager according to ThreadingPolicy  <a href="classsiggen_1_1_thread_manager_base.html#acb6c87062d2f75f4ad9d21801950e61e">More...</a><br /></td></tr>
<tr class="separator:acb6c87062d2f75f4ad9d21801950e61e inherit pub_static_methods_classsiggen_1_1_thread_manager_base"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classsiggen_1_1_thread_manager"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classsiggen_1_1_thread_manager')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classsiggen_1_1_thread_manager.html">siggen::ThreadManager</a></td></tr>
<tr class="memitem:acf2e72bb7f780cd77fd9f046c5f8c66c inherit pro_attribs_classsiggen_1_1_thread_manager"><td class="memItemLeft" align="right" valign="top"><a id="acf2e72bb7f780cd77fd9f046c5f8c66c"></a>
<a class="el" href="structsiggen_1_1_data.html">Data</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a></td></tr>
<tr class="memdesc:acf2e72bb7f780cd77fd9f046c5f8c66c inherit pro_attribs_classsiggen_1_1_thread_manager"><td class="mdescLeft">&#160;</td><td class="mdescRight">configuration for a thread manager <br /></td></tr>
<tr class="separator:acf2e72bb7f780cd77fd9f046c5f8c66c inherit pro_attribs_classsiggen_1_1_thread_manager"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>default thread manager using mutexes and condition variables </p>

<p class="definition">Definition at line <a class="el" href="_thread_manager_power_saver_8h_source.html#l00016">16</a> of file <a class="el" href="_thread_manager_power_saver_8h_source.html">ThreadManagerPowerSaver.h</a>.</p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a26a2a10c5fa543ea86c5058d69e0ee87"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a26a2a10c5fa543ea86c5058d69e0ee87">&#9670;&nbsp;</a></span>ConsumerThread()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void siggen::ThreadManagerPowerSaver::ConsumerThread </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>threadIndex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>basic loop for spawned consumer threads </p>
<p>Consumer thread tries to dequeue (block, data) in order to calculate to hash on dequeued block. If there is no data, it sleeps on condition variable. Otherwise it calculates the digest, and posts it to m_Signatures </p>

<p class="definition">Definition at line <a class="el" href="_thread_manager_power_saver_8cpp_source.html#l00028">28</a> of file <a class="el" href="_thread_manager_power_saver_8cpp_source.html">ThreadManagerPowerSaver.cpp</a>.</p>

</div>
</div>
<a id="ac96e31c7a171d9309dcb04b4232cec58"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac96e31c7a171d9309dcb04b4232cec58">&#9670;&nbsp;</a></span>ProcessToBuffer()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void siggen::ThreadManagerPowerSaver::ProcessToBuffer </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; char &gt; &amp;&#160;</td>
          <td class="paramname"><em>result</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>reads a block of data from input file, and enqueues the data for further processing by threads </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">result</td><td>buffer with resulting signatures</td></tr>
  </table>
  </dd>
</dl>
<p>The block of data is swapped with empty block from an idle thread and reading continues. At the end of the file it waits for all the threads to complete work, then writes resulting data to the buffer and terminates. </p>

<p>Implements <a class="el" href="classsiggen_1_1_thread_manager.html#a0526efee865fd31829ab17b1b3f27087">siggen::ThreadManager</a>.</p>

<p class="definition">Definition at line <a class="el" href="_thread_manager_power_saver_8cpp_source.html#l00064">64</a> of file <a class="el" href="_thread_manager_power_saver_8cpp_source.html">ThreadManagerPowerSaver.cpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/home/x/siggen/lib/include/<a class="el" href="_thread_manager_power_saver_8h_source.html">ThreadManagerPowerSaver.h</a></li>
<li>/home/x/siggen/lib/src/<a class="el" href="_thread_manager_power_saver_8cpp_source.html">ThreadManagerPowerSaver.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>siggen</b></li><li class="navelem"><a class="el" href="classsiggen_1_1_thread_manager_power_saver.html">ThreadManagerPowerSaver</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
